'use strict';exports.__esModule = true;var _requireAll = require('require-all');var _requireAll2 = _interopRequireDefault(_requireAll);
var _path = require('path');var _path2 = _interopRequireDefault(_path);
var _lodash = require('lodash');var _lodash2 = _interopRequireDefault(_lodash);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}

var rfileFilter = /(.+)\.(js|json|coffee)$/;exports.default =

{
  registerFolder: function registerFolder(rootDir, dir) {
    var dirname = _path2.default.resolve(rootDir, dir);
    var libs = (0, _requireAll2.default)({
      dirname: dirname,
      filter: rfileFilter });

    this.registerLibMap(libs);
    return this;
  },

  registerLibMap: function registerLibMap(libs) {var _this = this;
    _lodash2.default.each(libs, function (value, name) {
      if (libs.hasOwnProperty(name)) {
        var lib = libs[name];
        if (_lodash2.default.isFunction(lib)) {
          _this.addResolvableDependency(name, lib);
        } else if (_lodash2.default.isObject(lib)) {
          _this.registerLibMap(lib);
        }
      }
    });
    return this;
  },

  registerFolders: function registerFolders(rootDir, dirs) {var _this2 = this;
    _lodash2.default.each(dirs, function (dir) {return _this2.registerFolder(rootDir, dir);});
    return this;
  },

  registerLibraries: function registerLibraries(libraries) {var _this3 = this;
    this.logger.warn(
    'registerLibraries is deprecated, use registerDependencies with explicit require instead.');


    _lodash2.default.each(libraries, function (value, name) {
      if (libraries.hasOwnProperty(name)) {
        var lib = libraries[name];
        _this3.addDependency(name, require(lib)); // eslint-disable-line global-require
      }
    });
    return this;
  },

  registerDependencies: function registerDependencies(dependencies) {var _this4 = this;
    _lodash2.default.each(dependencies, function (value, name) {
      if (dependencies.hasOwnProperty(name)) {
        var lib = dependencies[name];
        _this4.addDependency(name, lib);
      }
    });
    return this;
  } };module.exports = exports['default'];
//# sourceMappingURL=RegistrationManagement.js.map